#!/usr/bin/perl

require "config.pl";

if ($ENV{'REQUEST_METHOD'} eq "GET") {
 $buffer = $ENV{'QUERY_STRING'};
} 
elsif ($ENV{'REQUEST_METHOD'} eq "POST") {
 read(STDIN, $buffer, $ENV{'CONTENT_LENGTH'});
}
@pairs = split(/&/, $buffer);
foreach $pair (@pairs) {
 ($name, $value) = split(/=/, $pair);
 $value =~ tr/+/ /;
 $value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
# $value =~ s/<([^>]|\n)*>//g;
 $value =~ s/<!--(.|\n)*-->//g;
 $value =~ s/\r//g;
 $value =~ s/\n//g;
 $value =~ s/\"/\'/g;
 $value =~ s/\|/\!/g;
 $FORM{$name} = $value;
}

&http_head;
&html_head;
$action = $FORM{'action'};
if ($action eq 'edittest') { &edittest; } #  
elsif ($action eq 'edithead') { &edithead; } #  
elsif ($action eq 'editqhead') { &editqhead; } #  
elsif ($action eq 'editqtext') { &editqtext; } #  
elsif ($action eq 'editqdel') { &editqdel; } #  
elsif ($action eq 'editqadd') { &editqadd; } # 
elsif ($action eq 'deletequest') { &deletequest; } # 
elsif ($action eq 'dropquest') { &dropquest; } # 
elsif ($action eq 'deleteall') { &deleteall; } #    IP
elsif ($action eq 'delete1') { &delete1; } # 1   IP     ( 0)
elsif ($action eq 'change') { &change; } #   IP
elsif ($action eq 'super') { &super; } #   
elsif ($action eq 'changeresume') { &changeresume; } #   
elsif ($action eq 'deletetest') { &deletetest; } # 
elsif ($action eq 'addtest') { &addtest; } # 
else { &admin; } 
&html_end;
exit;

sub adminform {
 $name = $FORM{'name'}; 
 &tab_start;
 print"<p>[<a href=\"$adminname?action=edittest&name=$name\"> </a>] ";
 print"[<a href=\"$cginame?action=open&name=$name\">  </a>]</p>";
 &tab_end;
 open (FILE, "$datafolder/$name/$name.ip");
 @ips = <FILE>;
 close(FILE);
 if (@ips) {
  &tab_start;
  print "<form action=$adminname method=post><input type=hidden name=action value=deleteall><input type=hidden name=name value=\"$name\"><input type=submit class=button name=ok value=\"    IP\"></form>\n";
  &tab_end;
  $count=0;
  foreach $line (@ips) {
   chomp($line);
   ($ip, $number, $balls) = split(/\|/, $line);
   print "<table border=0 width=$mainwidth><tr><td>";
   print "<form action=$adminname method=post>\n";
   print "<input type=hidden name=action value=change>\n";
   print "<input type=hidden name=name value=\"$name\">\n";
   print "<input type=hidden name=count value=\"$count\">\n";    
   print "IP: <input type=text name=ip value=$ip size=15 maxlength=15>\n";
   print ": <input type=text name=number value=$number size=4 maxlength=4>\n";
   print ": <input type=text name=balls value=$balls size=4 maxlength=4>\n";
   print "<input type=submit class=button name=ok value=\"\">\n";
   print "</form></td><td>\n";
   print "<form action=$adminname method=post>\n";
   print "<input type=hidden name=action value=delete1>\n";
   print "<input type=hidden name=name value=\"$name\">\n";
   print "<input type=hidden name=count value=\"$count\">\n";    
   print "<input type=submit class=button name=ok value=\"\"></form>\n";
   &tab_end;
   $count+=1;
  }
 } 
 else {
  &tab_start;
  print "<p> IP-,    , .   IP-      .</p>";
  &tab_end;
 }
}

sub admin {
 $name = $FORM{'name'}; 
 $password = $FORM{'password'}; 
 if ($password eq "") {
  &tab_start;
  print "<p>,       $name</p>";
  &tab_end;
  &linktoback;
 }
 else {
  open (DATA, "$datafolder/$name/$name.txt");
  @data = <DATA>;
  close (DATA);  
  if (@data) {
   $pass=@data[0];   
   chomp ($pass);
   if ($pass ne $password) {
    &tab_start;
    print "<p>,   <b>$password</b> </p>";
    &tab_end;
    &linktoback;
   }
   else {
    &adminform;
   }
  }
  else {
   &tab_start;
   print "<p>  <b>$name/$name.txt</b> .     <a href=\"$adminname\" action=edittest&name=$name></a></p>";
   &tab_end;
   &linktoback;
  }
 }
}

sub super1 { #  
 &linktoback;
 open (DATA, $tabname);
 @data = <DATA>;
 close (DATA);
 if (@data) {
  $count=0;
  foreach $line(@data) {
   chomp($line);
   ($name, $resume) = split(/\|/, $line);
   print "<table border=0 width=$mainwidth>";
   print "<tr><td> :</td><td>$name</td></tr>\n";
   print "<tr><td valign=top> :</td><td>";
   print "<form action=$adminname method=post>";
   print "<input type=hidden name=action value=changeresume>";
   print "<input type=hidden name=count value=\"$count\">";
   print "<textarea name=resume rows=5 cols=60>$resume</textarea>\n";
   print "<input type=submit class=button name=ok value=\" \">";
   print "</form>";
   print "<a href=\"$adminname?action=deletetest&count=$count\"> </a>&nbsp;";
   print "<a href=\"$adminname?action=edittest&name=$name\"> </a><p>&nbsp;</p>";
   &tab_end;   
   $count++;
  }
 }
 print "<form action=$adminname method=post>";
 print "<input type=hidden name=action value=addtest>";
 print "<table border=0 width=$mainwidth>";
 print "<tr><td> :</td><td><input type=text name=name size=8 maxlength=8></td></tr>\n";
 print "<tr><td><br>  :</td><td>";
 $count=0;
 print "<select name=count size=1>";
 foreach $line(@data) {
  chomp($line);
  ($name, $resume) = split(/\|/, $line);
  print "<option value=$count>$name</option>";
  $count++;
 }
 print "<option selected value=$count>  </option></select>";
 print "</td></tr>\n";
 print "<tr><td valign=top> :</td><td><textarea name=resume rows=5 cols=60></textarea><br>\n";
 print "<input type=submit class=button name=ok value=\" \">";
 &tab_end;    
 print "</form>";
}

sub super {
 $password = $FORM{'password'}; 
 if ($password eq "") {
  &tab_start;
  print "<p>,       $ENV{'SERVER_NAME'}</p>";
  &tab_end;
  &linktoback;
 }
 elsif ($password ne $adminpass) {
  &tab_start;
  print "<p>,   <b>$password</b> </p>";
  &tab_end;
  &linktoback;
 }
 else { #/ 
  &super1;
 }
}

sub deletetest {
 $count = $FORM{'count'}; 
 open (DATA, $tabname);
 @data = <DATA>;
 close (DATA);
 if (@data) {
  $number=0;
  $i=0;
  foreach $line(@data) {
   if ($number != $count) { $newdata[$i]=$line; $i++; }
   else { 
    ($name, $res) = split(/\|/, $line);
   }
   $number++;
  }
  open (DATA, ">$tabname");
  flock(DATA,2);
  truncate(DATA,0);
  print DATA @newdata;
  flock(DATA,8);
  close(DATA);
 }
 else {
  &tab_start;
  print "<p>         .</p>";
  &tab_end;
 }
 &tab_start;
 if (-e "$datafolder/$name/$name.ip") {
  unlink ("$datafolder/$name/$name.ip") or print "<p>    $name/$name.ip</p>";
 }
 if (-e "$datafolder/$name/$name.txt") {
  unlink ("$datafolder/$name/$name.txt") or print "<p>    $name/$name.txt</p>";
 }
 rmdir ("$datafolder/$name") or print "<p>    $name</p>";
 if (!(-d "$datafolder/$name")) {
  print "<p>   $name </p>";
 }
 &tab_end;
 &super1;
}

sub changeresume {
 $count = $FORM{'count'}; 
 $resume = $FORM{'resume'};   
 open (DATA, $tabname);
 @data = <DATA>;
 close (DATA);
 $number=0;
 $changed=0;
 foreach $line(@data) {
  if ($number != $count) { $newdata[$number]=$line; }
  else {  
   chomp($line);
   ($name, $resume0) = split(/\|/, $line);
   $newdata[$number]="$name\|$resume\n";
   $changed =1;
  }
  $number++;
 }
 &tab_start;
 $count+=1;
 if ($changed == 1) {
  print "<p>   $count  .</p>";
 }
 else {
  print "<p>      $count!</p>";
 }
 &tab_end;
 open (DATA, ">$tabname");
 flock(DATA,2);
 truncate(DATA,0);
 print DATA @newdata;
 flock(DATA,8);
 close(DATA);
 &super1;
}

sub latfilter { #     
 $value=@_[0];
 $value =~ s/<([^>]|\n)*>//g;
 $value =~ s/<!--(.|\n)*-->//g;
 $value =~ s/([--])//g;
 $value =~ s/ //g;
 $value =~ tr/([A-Z])/([a-z])/;
 return $value;
}

sub addtest {
 $count = $FORM{'count'}; 
 $name = $FORM{'name'}; 
 $name = latfilter ($name);
 if ($name eq "") {
  &tab_start;
  print "<p>,  \" \"      !  .</p>";
  &tab_end;
  &super1;
  exit;
 }
 $resume = $FORM{'resume'}; 
 open (DATA, $tabname);
 @data = <DATA>;
 close (DATA);
 $number=0;
 $added=0;
 foreach $line(@data) {
  chomp ($line);
  if ($line ne "") {
   if ($number == $count) { 
    $newdata[$number]="$name\|$resume\n"; 
    $added=1;
    $number++; 
   }
   $newdata[$number]="$line\n";
   $number++; 
  }
 }
 if ($added ==0) {
  $newdata[$number]="$name\|$resume";
 }
 open (DATA, ">$tabname");
 flock(DATA,2);
 truncate(DATA,0);
 print DATA @newdata;
 flock(DATA,8);
 close(DATA);
 &tab_start;
 print "<p>  $name </p>";
 &tab_end;
 &tab_start; # 
 if (!(-d "$datafolder/$name")) { mkdir ("$datafolder/$name",0777) or die "<p>    $name</p>"; }
 &tab_end;
 &super1;
}

sub edit2 { #  
 $name=@_[0];
 $number=@_[1];
 open (DATA, "$datafolder/$name/$name.txt");
 @data = <DATA>;
 close (DATA);
 if (@data) {
  $count=0;
  $i=0;
  foreach $line (@data) {
   chomp ($line);
   if ($line eq "") {
    $ndata[$count]=$i+1;
    $count++;
   }
   if ($i < $#data) { $data[$i]="$line\n"; }
   $i++;
  }
  #count -    
  $pass=$data[0];
  $balls=$data[1];
  if ($number == 0) { #   - 
   &edit_hdr ($name, $pass, $balls);   
   &quest ($name,$count,$number);
  }
  elsif ($number > $count) { # 
   &tab_start;
   print "<form action=$adminname method=post>\n";
   print "<input type=hidden name=action value=editqadd><input type=hidden name=name value=\"$name\"><input type=hidden name=number value=\"$number\">\n";
   print " : <input type=text name=text size=40 maxlength=255><br>\n";
   print " : <input type=text name=picture size=40 maxlength=255><br>\n";
   print "<input type=submit class=button name=ok value=\"OK\">\n";
   print "</form>\n";
   &tab_end;
   &quest ($name,$count,$number);
  }
  else { #  $number
   $start=$ndata[$number-1];
   chomp ($data[$start]);
   ($text,$pict,$vars)=split(/\|/, $data[$start]);
   $data[$start]="$data[$start]\n";
   &tab_start;
   print "<form action=$adminname method=post>\n";
   print "<input type=hidden name=action value=editqhead><input type=hidden name=name value=\"$name\"><input type=hidden name=number value=\"$number\">\n";
   print " : <input type=text name=text size=40 maxlength=255 value=\"$text\"><br>\n";
   print " : <input type=text name=picture size=40 maxlength=255 value=\"$pict\"></td><td>\n";
   print " : $number<br>\n  : $vars<br>\n";
   print "<input type=submit class=button name=ok value=\" \">\n";
   print "</form>\n";
   &tab_end;
   &tab_start;
   print "<form action=$adminname method=post><input type=hidden name=action value=deletequest><input type=hidden name=name value=\"$name\"><input type=hidden name=number value=\"$number\">\n";
   print "<input type=submit class=button name=ok value=\" \"></form></td><td>\n";
   print "<form action=$adminname method=post><input type=hidden name=action value=dropquest><input type=hidden name=name value=\"$name\"><input type=hidden name=number value=\"$number\">\n";
   print "  :<select name=\"newnumber\" size=1>";
   for ($i=0; $i<$count; $i++) {
    $i1=$i+1;
    print "<option value=\"$i\">$i1</option>";
   }
   print "<option value=\"$count\" selected> </option>";
   print "</select><input type=submit class=button name=ok value=\"\"></form></td><td>\n";
   &tab_end;
   $error=0;
   &tab_start;
   print "<table cellpadding=3 cellspacing=0 width=\"100%\" border=1><tr><td align=center></td><td align=center> </td><td align=center>  </td><td align=center></td><td align=center></td></tr>\n";
   for ($i=$start+1,$n=0; $i<$start+1+$vars; $i++) {
    chomp ($data[$i]);
    ($variant,$ball)=split(/\|/, $data[$i]);
    if ($ball<0) { $error=1; $ball=0; }
    elsif ($ball>$balls) { $error=1; $ball=$balls; }
    $data[$i]="$variant\|$ball\n";
    $n++;
    print "<tr><td><form action=$adminname method=post>\n";
    print "<input type=hidden name=name value=\"$name\"><input type=hidden name=action value=editqtext><input type=hidden name=number value=\"$number\"><input type=hidden name=numvar value=\"$n\">\n";
    print "$n)</td><td><input type=text size=40 maxlength=255 name=variant value=\"$variant\"></td>";
    print "<td align=center><select name=ball size=1>";
    for ($j=0; $j<=$balls; $j++) {
     print "<option value=$j";
     if ($j == $ball) { print " selected"; }
     print ">$j</option>";
    }
    print "</select></td>\n";
    print "<td align=center><input type=submit class=button name=ok value=\" $n\"></form></td>\n";
    print "<td align=center><form action=$adminname method=post>\n";
    print "<input type=hidden name=name value=\"$name\"><input type=hidden name=action value=editqdel><input type=hidden name=number value=\"$number\"><input type=hidden name=numvar value=\"$n\">\n";
    print "<input type=submit class=button name=ok value=\"Del $n\"></form></td></tr>\n";
   }
   if ($error == 1) {
    print "<tr><td colspan=5>";
    print "<p>!  ,   .    -  0  $balls. ,         ,       !</p>\n";
    print "</td></tr>";
   }
   print "<tr><td><form action=$adminname method=post>\n";
   $vars1=$vars+1;
   print "<input type=hidden name=name value=\"$name\"><input type=hidden name=action value=editqtext><input type=hidden name=number value=\"$number\"><input type=hidden name=numvar value=\"$vars1\">\n";
   print ":</td><td><input type=text size=40 maxlength=255 name=variant value=\"\"></td>";
   print "<td align=center><select name=ball size=1>";
   for ($j=0; $j<=$balls; $j++) {
    print "<option value=$j>$j</option>";
   }
   print "</select></td>";
   print "<td align=center><input type=submit class=button name=ok value=\"OK $vars1\"></form></td><td>&nbsp;</td></tr></table>\n";
   &tab_end;
   &quest ($name,$count,$number);
  }
 }
 else { #  
  &edit_hdr ($name,"","1");   
 }
 &tab_start;
 print"[<a href=\"$cginame?action=open&name=$name\">  </a>]</p>";
 &tab_end;
 &linktoback;
}

sub edithead { #  
   $name = $FORM{'name'}; 
   $password=$FORM{'password'};
   $balls=$FORM{'balls'};
   open (DATA, "$datafolder/$name/$name.txt");
   @data = <DATA>;
   close (DATA);
   if ($password eq "") {
    &tab_start;
    print "<p>,      </p>";
    &tab_end;
    &edit_hdr ($name, $password, $balls);
   }
   elsif ($balls<1) {
    &tab_start;
    print "<p>,        1</p>";
    &tab_end;
    &edit_hdr ($name, $password, $balls);
   }
   elsif (@data) { 
    $data[0]="$password\n";
    $data[1]="$balls\n";
    open (DATA, ">$datafolder/$name/$name.txt");
    flock(DATA,2);
    truncate(DATA,0);
    print DATA @data;
    flock(DATA,8);
    close(DATA);
    &tab_start;
    print "<p>   $name </p>";
    &tab_end;
    &edit2 ($name,0);
   }
   else { #   
    open (DATA, ">$datafolder/$name/$name.txt");
    flock(DATA,2);
    truncate(DATA,0);
    print DATA "$password\n$balls\n";
    flock(DATA,8);
    close(DATA);
    &tab_start;
    print "<p>   $name </p>";
    &tab_end;
    &edit2 ($name,0);
   }
}

sub edit_hdr { #   
 $name=@_[0];
 $pass=@_[1];
 $balls=@_[2];
 &tab_start;  
 print "<p><b>    $name:</b></p>";
 print "<form action=$adminname method=post><input type=hidden name=action value=edithead><input type=hidden name=name value=$name>\n";
 print "<p>        :<br>\n";
 print "<input type=password size=10 maxlength=10 name=password value=\"$pass\"></p>\n";
 print "<p>   ,       :<br>\n";
 print "<input type=text size=2 maxlength=2 name=balls value=\"$balls\"></p>\n";
 print "<input type=submit class=button name=ok value=\"\">\n";
 print "</form>";
 &tab_end;
}

sub quest { #  
 $name=@_[0];
 $num=@_[1];
 $number=@_[2];
 &tab_start; 
 if ($number != 0) {
  print "<p>[<a href=\"$adminname?action=edittest&name=$name&number=0\"></a>]\n"; 
 }
 if ($num>0) {
  print " : ";
  for ($i=1; $i<=$num; $i++) {
   if ($i == $number) {
    print "[$i] ";
   }
   else {
    print "[<a href=\"$adminname?action=edittest&name=$name&number=$i\">$i</a>] ";
   }
  }
 }
 $num++;
 print "[<a href=\"$adminname?action=edittest&name=$name&number=$num\"></a>]</p>\n";
 &tab_end;
}

sub dropquest { # 
 $name = $FORM{'name'}; 
 $number = $FORM{'number'}; 
 $newnumber = $FORM{'newnumber'}; 
 open (DATA, "$datafolder/$name/$name.txt");
 @data = <DATA>;
 close (DATA);
 if (@data) {
  $count=0;
  $i=0;
  foreach $line (@data) {
#   chomp ($line);
   if ($line eq "\n") {
    $ndata[$count]=$i+1;
    $count++;
   }
#   if ($i < $#data) { $data[$i]="$data[$i]\n"; }
   $i++;
  }
  if ($number == $newnumber) {
   &tab_start;
   print "<p>     $number</p>";
   &tab_end;
  }
  elsif ($number == $newnumber+1) {
   &tab_start;
   print "<p>     $number</p>";
   &tab_end;
  }
  elsif (($number>0) and ($number<=$count) and ($newnumber>=0) and ($newnumber<=$count)) {
   $start=$ndata[$number-1]-1;
   if ($number==$count) { $ends=$#data+1; }
   else { $ends=$ndata[$number]-1; }
   @newdata=splice (@data, $start, $ends-$start);
   if ($newnumber==0) { $c=-1; }
   else { $c=0; }
   $i=0;
   $found=0;
   foreach $line (@data) {   
    if ($line eq "\n") {
     $c++;
     if ($c == $newnumber) {
      $found=1;
      for ($j=0; $j<=$#newdata; $j++) {
       @data2[$i]=$newdata[$j];
       if (($number==$count) and ($j==$#newdata)) {
        @data2[$i]="@data2[$i]\n";
       }
       $i++;
      }
      if ($newnumber < $count) {
       @data2[$i]="\n";
       $i++;
      }
     }
     else {
      @data2[$i]="\n";
      $i++;
     }
    }
    else {
     $data2[$i]=$line;
     $i++;
    }
   }
   if ($found==0) { # 
    if ($data2[$i-1] ne "\n") { $data2[$i]="\n"; $i++; }
    for ($j=0; $j<=$#newdata; $j++) {
     @data2[$i]=$newdata[$j];
     $i++;
    }
   }
   if ($newnumber == $count) { $n1=$count; }
   elsif ($newnumber == 0) { $n1=1; }
   elsif ($newnumber<$number) { $n1=$newnumber; }
   else { $n1=$newnumber; }
   chomp ($data2[$#data2]);
   open (DATA, ">$datafolder/$name/$name.txt");
   flock(DATA,2);
   truncate(DATA,0);
   print DATA @data2;
   flock(DATA,8);
   close(DATA);
   &tab_start;
   print "<p> $number    $n1</p>";
   &tab_end;
  }
  else {
   &tab_start;
   print "<p>       (number=$number, newnumber=$newnumber)!      -  0  $count</p>";
   &tab_end;
  }
 }
 else {
  &tab_start;
  print "<p> $name   !</p>";
  &tab_end;
 }
 &edit2 ($name, $number);
}

sub deletequest { # 
 $name = $FORM{'name'}; 
 $number = $FORM{'number'}; 
 open (DATA, "$datafolder/$name/$name.txt");
 @data = <DATA>;
 close (DATA);
 if (@data) {
  $count=0;
  $i=0;
  foreach $line (@data) {
   chomp ($line);
   if ($line eq "") {
    $ndata[$count]=$i+1;
    $count++;
   }
   if ($i < $#data) { $data[$i]="$data[$i]\n"; }
   $i++;
  }
  if (($number>0) and ($number<=$count)) {
   $start=$ndata[$number-1]-1;
   if ($number==$count) { $ends=$#data; }
   else { $ends=$ndata[$number]-1; }
   splice (@data, $start, $ends-$start);
   open (DATA, ">$datafolder/$name/$name.txt");
   flock(DATA,2);
   truncate(DATA,0);
   print DATA @data;
   flock(DATA,8);
   close(DATA);
   &tab_start;
   print "<p> $number </p>";
   &tab_end;
  }
  else {
   &tab_start;
   print "<p>      !      -  0  $count</p>";
   &tab_end;
  }
 }
 else {
  &tab_start;
  print "<p> $name   !</p>";
  &tab_end;
 }
 &edit2 ($name, $number);
}

sub editqhead { #  
 $name = $FORM{'name'}; 
 $number = $FORM{'number'};
 $text = $FORM{'text'}; 
 $picture = $FORM{'picture'}; 
 open (DATA, "$datafolder/$name/$name.txt");
 @data = <DATA>;
 close (DATA);
 if (@data) {
  $count=0;
  $i=0;
  foreach $line (@data) {
   chomp ($line);
   if ($line eq "") {
    $ndata[$count]=$i+1;
    $count++;
   }
   if ($i < $#data) { $data[$i]="$data[$i]\n"; }
   $i++;
  }
  if (($number>0) and ($number<=$count)) {
   $start=$ndata[$number-1];
   chomp ($data[$start]);
   ($text1,$pict,$vars)=split(/\|/, $data[$start]);   
   $data[$start]="$text\|$picture\|$vars\n";
   open (DATA, ">$datafolder/$name/$name.txt");
   flock(DATA,2);
   truncate(DATA,0);
   print DATA @data;
   flock(DATA,8);
   close(DATA);
   &tab_start;
   print "<p>  $number </p>";
   &tab_end;
  }
  else {
   &tab_start;
   print "<p>      !      -  0  $count</p>";
   &tab_end;
  }
 }
 else {
  &tab_start;
  print "<p> $name   !</p>";
  &tab_end;
 }
 &edit2 ($name, $number);
}

sub editqadd { # 
 $name = $FORM{'name'}; 
 $number = $FORM{'number'};
 $text = $FORM{'text'}; 
 $picture = $FORM{'picture'}; 
 if ($text eq "") {
  &tab_start;
  print "<p>,      </p>";
  &tab_end;
 }
 else {
  open (DATA, ">>$datafolder/$name/$name.txt");
  flock(DATA,2);
  if ($number> 1 ) { print DATA "\n"; }
  print DATA "\n$text\|$picture\|0";
  flock(DATA,8);
  close(DATA);
  &tab_start;
  print "<p> $number .</p>";
  &tab_end;
 }
 &edit2 ($name, $number);
}

sub editqtext { #  
 $name = $FORM{'name'}; 
 $number = $FORM{'number'};
 $numvar = $FORM{'numvar'}; 
 $variant = $FORM{'variant'}; 
 $ball = $FORM{'ball'}; 
 open (DATA, "$datafolder/$name/$name.txt");
 @data = <DATA>;
 close (DATA);
 if (@data) {
  $count=0;
  $i=0;
  foreach $line (@data) {
   chomp ($line);
   if ($line eq "") {
    $ndata[$count]=$i+1;
    $count++;
   }
   if ($i < $#data) { $data[$i]="$data[$i]\n"; }
   $i++;
  }
  $start=$ndata[$number-1];
  chomp ($data[$start]);
  ($text,$pict,$vars)=split(/\|/, $data[$start]);
  $data[$start]="$data[$start]\n";
  if ($numvar > $vars) {
   $data[$start]="$text\|$pict\|$numvar\n";
   for ($i=$#data+1; $i>$start+$numvar; $i--) {
    $data[$i]=$data[$i-1];
   }
  }
  if ($start+$numvar > $#data) { 
   if ($vars>0) { $data[$#data]="$data[$#data]\n"; }
   $data[$start+$numvar]="$variant\|$ball";
  }
  else {
   $data[$start+$numvar]="$variant\|$ball\n";
  }
  open (DATA, ">$datafolder/$name/$name.txt");
  flock(DATA,2);
  truncate(DATA,0);
  print DATA @data;
  flock(DATA,8);
  close(DATA);
  &tab_start;
  print "<p> $number .</p>";
  &tab_end;
 }
 else {
  &tab_start;
  print "<p> $name  !</p>";
  &tab_end;
 }
 &edit2 ($name, $number);
}

sub editqdel { #  
 $name = $FORM{'name'}; 
 $number = $FORM{'number'};
 $numvar = $FORM{'numvar'}; 
 open (DATA, "$datafolder/$name/$name.txt");
 @data = <DATA>;
 close (DATA);
 if (@data) {
  $count=0;
  $i=0;
  foreach $line (@data) {
   chomp ($line);
   if ($line eq "") {
    $ndata[$count]=$i+1;
    $count++;
   }
   if ($i < $#data) { $data[$i]="$data[$i]\n"; }
   $i++;
  }
  $start=$ndata[$number-1];
  chomp ($data[$start]);
  ($text,$pict,$vars)=split(/\|/, $data[$start]);
  if ($vars >0) { $vars--; }
  $data[$start]="$text\|$pict\|$vars\n";
  splice (@data, $start+$numvar, 1);

  open (DATA, ">$datafolder/$name/$name.txt");
  flock(DATA,2);
  truncate(DATA,0);
  print DATA @data;
  flock(DATA,8);
  close(DATA);
  &tab_start;
  print "<p>  $numvar  $number .</p>";
  &tab_end;
 }
 else {
  &tab_start;
  print "<p> $name  !</p>";
  &tab_end;
 }
 &edit2 ($name, $number);
}

sub edittest { #  
 $name = $FORM{'name'}; 
 if ($FORM{'number'}) { $number = $FORM{'number'}; }
 else { $number=0; } 
 &edit2 ($name, $number);
}

sub change {
 $name = $FORM{'name'}; 
 $count = $FORM{'count'}; 
 $ip = $FORM{'ip'}; 
 $number = $FORM{'number'}; 
 $balls = $FORM{'balls'};
 
 $error=0;
 @octets=split(/\./,$ip);
 for ($i=0; $i<4; $i+=1) {
  if (($octets[$i]<0) or ($octets[$i]>255)) {
   &tab_start;
   print "<p>      IP-: <b>$ip</b></p>";
   &tab_end;
   $error=1;
  }
 }
 open (DATA, "$datafolder/$name/$name.txt");
 @data = <DATA>;
 close (DATA);
 if (@data) {
  $all=0;
  for ($i=2; $i<=$#data; $i+=1) {
   chomp ($data[$i]);
   if ($data[$i] eq "") {
    $all +=1;
   }
  }
  $all-=1;
  if (($number<0) or ($number>$all)) {
   &tab_start;
   print "<p>        : <b>$number</b> (    :  0  $all)</p>";
   &tab_end;
   $error=1;
  }
  $maxball=($data[1])*($number+1);
  if (($balls<0) or ($balls>$maxball)) {
   &tab_start;
   print "<p>       : <b>$balls</b> (       $number :  0  $maxball)</p>";
   &tab_end;
   $error=1;
  }
 }
 else {
  &tab_start;
  print "<p>  <b>$name/$name.txt</b> .     <a href=\"$adminname\" action=edittest></a></p>";
  &tab_end;
  &adminform;
  exit;
 }
 if ($error==1) {
  &tab_start;
  print "<p>  !</p>";
  &tab_end;
  &adminform;
  exit;
 }
 open (FILE, "$datafolder/$name/$name.ip");
 @ips = <FILE>;
 close(FILE);
 if (@ips) {
  $n = 0;
  $found = 0;
  foreach $line (@ips) {
   if ($count == $n) {
    $line = "$ip\|$number\|$balls\n";
    $found =1;
   }
   $newip[$n]=$line;
   $n+=1;
  }
  if ($found == 0) {
   &tab_start;
   print "<p>           <b>$count</b> (IP=$ip, =$number, =$balls).      !</p>";
   &tab_end;
  }
  else {
   &tab_start;
   print "<p>   <b>$count</b>   (IP=$ip, =$number, =$balls).</p>";
   &tab_end;
  }
  open (FILE, ">$datafolder/$name/$name.ip");
  flock(FILE,2);
  truncate(FILE,0);
  print FILE @newip;
  flock(FILE,8);
  close(FILE);
 }
 &adminform;
}

sub deleteall {
 $name = $FORM{'name'}; 
 if (-e "$datafolder/$name/$name.ip") {
  if (unlink ("$datafolder/$name/$name.ip")) {
   &tab_start;
   print "<p> <b>$name/$name.ip</b> </p>";
   &tab_end;
  }
  else { print "<p>    $name/$name.ip</p>"; }
 }
 &adminform;
}

sub delete1 {
 $name = $FORM{'name'}; 
 $count = $FORM{'count'}; 
 open (FILE, "$datafolder/$name/$name.ip");
 @ips = <FILE>;
 close(FILE);
 if (@ips) {
  $number = 0;
  $found = 0;
  foreach $line (@ips) {
   if ($count == $number) {
    $found =1;
   }
   else {
    $newip[$number]=$line;
   }
   $number+=1;
  }
  if ($found == 0) {
   &tab_start;
   print "<p>           <b>$count</b>.      !</p>";
   &tab_end;
  }
  else {
   &tab_start;
   print "<p>   <b>$count</b>  </p>";
   &tab_end;
  }
  open (FILE, ">$datafolder/$name/$name.ip");
  flock(FILE,2);
  truncate(FILE,0);
  print FILE @newip;
  flock(FILE,8);
  close(FILE);
 }
 &adminform;
}

